=== debian/changelog ===
tcc (0.9.27-1) unstable; urgency=low

  * Initial release (Closes: #nnnn)  <nnnn is the bug number of your ITP>

 -- sunshavi <sunshavi@yahoo.com>  Fri, 12 Jun 2015 11:07:30 -0500
