=== debian/control ===
Source: tcc
Section: user/development
Priority: extra
Maintainer: sunshavi <sunshavi@yahoo.com>
Build-Depends: debhelper (>= 5), autotools-dev
Standards-Version: 3.7.2

Package: tcc
Architecture: any
Depends: ${shlibs:Depends}, libc6
Description: the smallest ANSI C compiler
 TCC (for Tiny C Compiler) is a small and fast ANSI C compiler. See http://www.tinycc.org

Package: tcc-doc
Architecture: all
Description: Documentation for tcc
 <insert long description, indented with spaces>
